#!/bin/sh

echo 0 > /sys/class/graphics/fbcon/cursor_blink

CAM_ENTITY_NUMBER=vm050@4a
CAM_BW_FMT=Y8
IPU0_CSI0_DEVICE=$(media-ctl -e "ipu0-csi0-video")
IPU1_CSI1_DEVICE=$(media-ctl -e "ipu1-csi1-video")
CAM_DEVICE=$(media-ctl -e "vm050@4a")
CAM_I2C_BUS=$(find /sys/bus/i2c/drivers/phytec-vm050/ -name "?-00*" | cut -d / -f 7 | cut -c1-1)
CAMERA_TYP=$(i2cget -y -f $CAM_I2C_BUS 0x4a 0x00 w | cut -c 4)

if [ "$CAMERA_TYP" = "1" ]; then
	CAMERA="VM-050"
	GRAB_RES="16x16"
	FRAME_SIZE=",width=16,height=16"
	FRAME_SCALE_SIZE=",width=160,height=160"
	OFFSET="(16,16)"
elif [ "$CAMERA_TYP" = "2" ]; then
	CAMERA="VM-051"
	GRAB_RES="40x32"
	FRAME_SIZE=",width=40,height=32"
	FRAME_SCALE_SIZE=",width=240,height=192"
	OFFSET="(40,32)"
else
	echo " no camera driver loaded"
	echo " please check camera device tree" 
	echo ""
	return 1
fi

echo ""
echo " found camera = $CAMERA"
echo " camera entity name = $CAM_ENTITY_NUMBER"
echo " camera subdevice name = $CAM_DEVICE"
echo " ipu0_CSI0 devive name = $IPU0_CSI0_DEVICE"
echo " ipu1_CSI1 devive name = $IPU1_CSI1_DEVICE"
echo ""

echo ""
echo " configure IPU/VPU with media_control"
echo " ===================================="
media-ctl -r
media-ctl -V "\"$CAM_ENTITY_NUMBER\":0[fmt:$CAM_BW_FMT/$GRAB_RES $OFFSET/$GRAB_RES]"
media-ctl -V '"ipu0-csi0-sd":0[fmt:Y8/'$GRAB_RES']'
media-ctl -V '"ipu0-csi0-sd":1[fmt:Y8/'$GRAB_RES']'

echo ""
echo " start gstreamer, break with ctl-C"
echo " ================================="

v4l2-ctl -d /dev/v4l/by-name/vm050@4a --set-ctrl=autoscale_mode=1

gst-launch-1.0 \
	v4l2src device=$IPU0_CSI0_DEVICE ! \
	video/x-raw,format=GRAY8,depth=8$FRAME_SIZE ! \
	pseudocolor2 mode=table invert=0 ! video/x-raw,format=RGB$FRAME_SIZE ! \
	videoscale ! video/x-raw$FRAME_SCALE_SIZE ! \
	videoconvert ! \
	queue ! kmssink driver-name="imx-drm" scale=false sync=false
#	fbdevsink sync = false


echo 1 > /sys/class/graphics/fbcon/cursor_blink
